/*Memory*/
unsigned char *ram;
unsigned char *lorom;
unsigned char *hirom[16];
unsigned char *readarray[4],*writearray[4];

/*Z80*/
typedef union
{
        unsigned short w;
        struct
        {
                unsigned char l,h;
        } b;
} z80reg;

z80reg af,bc,de,hl,ix,iy,ir,saf,sbc,sde,shl;
unsigned short pc,sp;
int iff1,iff2;
int intreq;
int im;

#define N_FLAG 0x80
#define Z_FLAG 0x40
#define H_FLAG 0x10
#define P_FLAG 0x04
#define V_FLAG 0x04
#define S_FLAG 0x02
#define C_FLAG 0x01

void initz80();
void resetz80();
void loadroms();
void execz80();

/*GA*/
void writega(unsigned short a, unsigned char v);
int galines;
int gapal[16],gaborder;
int palchange;
int scrmode;

/*8255 PIA*/
void write8255(unsigned short a, unsigned char v);
unsigned char read8255(unsigned short a);

/*PSG*/
int psgmode;
unsigned char psgdat;
void updatepsg();
void updatekeys(int line);
int loromena,hiromena,curhrom;
unsigned char psgreg,psgregs[16];
int psgvols[4][512];
int psglatchs[5][512];

/*CRTC*/
void writecrtc(unsigned short a, unsigned char v);
unsigned char readcrtc(unsigned short a);
int crtcvsync;
